function [g, roct, exitflag, gval]=boxcoxcens(x,y,statusx,statusy,init)


xcen1=x;
ycen1=y;
options=optimset('MaxFunEvals',10000,'MaxIter',10000,'TolX',10^(-8));
trun=@(g) normcdf( sign(g(3)).*abs( (g(3).*g(1)+1)./(g(3).*g(2)) )); 

% DOUBLE CENSORING WITH TRUNCATION TERM AND TWO POPULATIONS:
fx=@(x,g) x.^(g(3)-1).*normpdf((x.^g(3)-1)./g(3),g(1),g(2))./trun([g(1) g(2) g(3)]);
Fx=@(x,g) 1./trun([g(1) g(2) g(3)]).*( normcdf(x.^g(3)/(g(3).*g(2)) - ((1+g(3).*g(1))./(g(3).*g(2))) ) - normcdf(-(1+g(3).*g(1))./(g(3).*g(2)))   );
Sx=@(x,g) 1-Fx(x,g);

fy=@(y,g) y.^(g(3)-1).*normpdf((y.^g(3)-1)./g(3),g(1),g(2))./trun([g(1) g(2) g(3)]);
Fy=@(y,g) 1./trun([g(1) g(2) g(3)]).*( normcdf(y.^g(3)/(g(3)*g(2)) - ((1+g(3).*g(1))./(g(3).*g(2))) ) - normcdf(-(1+g(3).*g(1))./(g(3).*g(2)))   );
Sy=@(y,g) 1-Fy(y,g);


logL=@(g) -sum( (statusx==-1).*log(Fx(xcen1,[g(1) g(2) g(5)]))      +   (statusx==0).*log(fx(xcen1,[g(1) g(2) g(5) ]) ) +  (statusx==1).*log(Sx(xcen1,[g(1) g(2) g(5)])) )+...
          -sum( (statusy==-1).*log(Fy(ycen1,[g(3) g(4) g(5)]))      +   (statusy==0).*log(fy(ycen1,[g(3) g(4) g(5) ]) ) +  (statusy==1).*log(Sy(ycen1,[g(3) g(4) g(5)])) );


      
    
if nargin<5
[g gval exitflag]=fminsearch(logL,[mean(xcen1)-1 std(xcen1) mean(ycen1)-1 std(ycen1) 1],options);
else
[g gval exitflag]=fminsearch(logL,[init],options);
end

lamcen=g(5);
mxhat=g(1);
sxhat=g(2);
myhat=g(3);
syhat=g(4);



%roct=@(t) 1-normcdf(norminv(1-t,mxhat,sxhat),myhat,syhat);


%Define the truncated normal based ROC:
Qcdf=@(x,m,s,a,b) ((normcdf(x,m,s)-normcdf(a,m,s))/(normcdf(b,m,s)-normcdf(a,m,s))).*(x>a & b>x); %cdf
Qinv=@(u,m,s,a,b) norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s).*(norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s)>a & b>norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s));  %inv
%Qinv=@(u,m,s,a,b) norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s)%.*(norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s)>a & b>norminv(normcdf(a,m,s)+u*(normcdf(b,m,s)-normcdf(a,m,s)) ,m,s));  %inv

roct=@(t) 1-Qcdf(Qinv(1-t,mxhat,sxhat,-1/lamcen,Inf),myhat,syhat,-1/lamcen,Inf);




end