
function [out exitflag]=rocLODkernBCt(xcen1,xcen2,status1, status2, cutlow, cutupp,init)
%========GENERALIZED GAMMA=============
options=optimset('MaxFunEvals',18000,'MaxIter',18000);
 
%Use the broader model of the generalized model
%Z=[ones(length(xcen1),1) data(:,3)];
%[pars covpars SE CI Zscores pvalues gval exitflag]=aft(xcen1,[Z],statusx,'gamma',[],1,[],1);
statusx=status1;
statusy=status2;


status1=statusx;
status2=statusy;
y1=xcen1;
y2=xcen2;
ft=@(t, tau) tpdf(t, tau);
Ft=@(t, tau) tcdf(t, tau);
Ftinv=@(u,tau) tinv(u,tau);

fz=@(z,s,v,tau) ft(z,tau)./Ft(1./(s*abs(v)),tau);
Fz=@(z,s,v,tau) (Ft(z, tau) - (v>0).*Ft(-1./(s.*abs(v)),tau))./ (Ft(1./(s.*abs(v)),tau));
Finvz=@(u,s,v,tau) (v<=0).*Ftinv(u.*Ft(1./(s.*abs(v)),tau),tau) + (v>0).*Ftinv(1-(1-u).*Ft(1./(s.*abs(v)),tau),tau);

fy=@(y,g) y.^(g(3)-1)./(g(2).*g(1).^g(3)).*fz(1/(g(2).*g(3)).*((y./g(1)).^g(3)-1),g(2),g(3),g(4));
Fy=@(y,m,s,v,tau) (Ft((1/(s.*v).*((y./m).^v-1)), tau) - (v>0).*Ft(-1./(s.*abs(v)),tau))./ (Ft(1./(s.*abs(v)),tau));
logL=@(g) - sum((status1==-1).*log(Fy(y1,g(1), g(2), g(3), g(4)))  +  (status1==0).*log(fy(y1,[g(1) g(2) g(3) g(4)]))  +  (status1==1).*log(1-Fy(y1,g(1), g(2), g(3), g(4))))+...
          - sum((status2==-1).*log(Fy(y2,g(5), g(6), g(7), g(8)))  +  (status2==0).*log(fy(y2,[g(5) g(6) g(7) g(8)]))  +  (status2==1).*log(1-Fy(y2,g(5), g(6), g(7), g(8))));
      
            %init=[7.0006    0.1389    0.3777   14.3656    8.1292    0.1079    1.6064   50.9868];


      
[g gval exitflag]=fminsearchbnd(logL,init,[0 0 -Inf 0 0 0 -Inf 0], [Inf Inf Inf Inf Inf Inf Inf Inf], options);
g
m1=g(1);
s1=g(2);
v1=g(3);
tau1=g(4);

m2=g(5);
s2=g(6);
v2=g(7);
tau2=g(8);



ft=@(t, tau) tpdf(t, tau);
Ft=@(t, tau) tcdf(t, tau);
Ftinv=@(u,tau) tinv(u,tau);

za=@(a,s,v,tau) (v<=0).*Ftinv(a*Ft(1/(s*abs(v)),tau),tau)  +  (v>0).*Ftinv(1-(1-a)*Ft(1/(s*abs(v)),tau),tau);
Fyinv=@(t,m,s,v,tau) m.*(1+s.*v.*za(t,s,v,tau)).^(1./v)  ;


Sinva=@(u) Fyinv(1-u,m1,s1,v1,tau1);
Sinvb=@(u) Fyinv(1-u,m2,s2,v2,tau2);

rocBCT=@(t) 1-Fy(Fyinv(1-t,m1,s1,v1,tau1),m2,s2,v2,tau2);
t=0:0.01:1;
incr=rocBCT(t);
exx=issorted(incr(5:(end-10)));

%figure
%plot(t,rocBCT(t),'m')


logos1left=length(find(status1==-1));
logos2left=length(find(status2==-1));

logos1right=length(find(status1==1));
logos2right=length(find(status2==1));

%exitflaggggggggggggg=exitflag

if exitflag~=1 || exx~=1
warning('BCt did not converge')'
out=NaN;
exitflag=0;
else
    exitflag=1;

%raaaaaa=Sinva(rand)
%rbbbbbb=Sinvb(rand)

%gr=0:0.01:(5*max(max(xcen1),max(xcen2)))
improct=[];
for impnum=1:30
  impnum;
  
%==================Deal with left censoring
rimp=[];kkk=0;
cut=cutlow;
for i=1:logos1left;
    while length(rimp)<logos1left;r=Sinva(rand);%r=Qrand(a1hat,b1hat,-1/lamcen,Inf);r=normrnd(a1hat,b1hat,1,1);
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2left;
    while length(rimp)<logos2left;r=Sinvb(rand);%r=Qrand(a2hat,b2hat,-1/lamcen,Inf);r=normrnd(a2hat,b2hat,1,1);
    if r<cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==-1)=ximp1;
xcen2(status2==-1)=ximp2;

%==========================Deal with right censoring

rimp=[];kkk=0;
cut=cutupp;
for i=1:logos1right;
    while length(rimp)<logos1right;r=Sinva(rand);%r=Qrand(a1hat,b1hat,-1/lamcen,Inf);r=normrnd(a1hat,b1hat,1,1);
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp1=rimp;
%disp('fine....')
rimp=[];
for i=1:logos2right;
    while length(rimp)<logos2right;r=Sinvb(rand);%r=Qrand(a2hat,b2hat,-1/lamcen,Inf);r=normrnd(a2hat,b2hat,1,1);
    if r>cut;rimp=[rimp;r];end;
    end
end
ximp2=rimp;

xcen1(status1==1)=ximp1;
xcen2(status2==1)=ximp2;





%scores=[xcen1;xcen2];
%labels=[zeros(length(xcen1),1);ones(length(xcen2),1)];
%[Ximp Yimp Timp AUCimp(impnum)]=perfcurve(labels,scores,1);
%AUCimp(impnum);
%hold on
%plot(Ximp,Yimp,'g')

%=========kernels================================================
W1a=xcen1;W1b=xcen2;
W1a;
W1b;
h1a=0.9*min(std(W1a),iqr(W1a)/1.34)*length(W1a)^(-0.2);
h1b=0.9*min(std(W1b),iqr(W1b)/1.34)*length(W1b)^(-0.2);

Sinv1a=@(t) ksdensity(W1a,1-t,'width',h1a,'function','icdf');
rock=@(t) 1-ksdensity(W1b,Sinv1a(t),'width',h1b,'function','cdf');
%tt=0:0.01:1;
%plot(tt,rock(t),'y')
%=========kernels================================================


if impnum==1;rock1=@(t) rock(t);end
if impnum==2;rock2=@(t) rock(t);end
if impnum==3;rock3=@(t) rock(t);end
if impnum==4;rock4=@(t) rock(t);end
if impnum==5;rock5=@(t) rock(t);end
if impnum==6;rock6=@(t) rock(t);end
if impnum==7;rock7=@(t) rock(t);end
if impnum==8;rock8=@(t) rock(t);end
if impnum==9;rock9=@(t) rock(t);end
if impnum==10;rock10=@(t) rock(t);end
if impnum==11;rock11=@(t) rock(t);end
if impnum==12;rock12=@(t) rock(t);end
if impnum==13;rock13=@(t) rock(t);end
if impnum==14;rock14=@(t) rock(t);end
if impnum==15;rock15=@(t) rock(t);end
if impnum==16;rock16=@(t) rock(t);end
if impnum==17;rock17=@(t) rock(t);end
if impnum==18;rock18=@(t) rock(t);end
if impnum==19;rock19=@(t) rock(t);end
if impnum==20;rock20=@(t) rock(t);end
if impnum==21;rock21=@(t) rock(t);end
if impnum==22;rock22=@(t) rock(t);end
if impnum==23;rock23=@(t) rock(t);end
if impnum==24;rock24=@(t) rock(t);end
if impnum==25;rock25=@(t) rock(t);end
if impnum==26;rock26=@(t) rock(t);end
if impnum==27;rock27=@(t) rock(t);end
if impnum==28;rock28=@(t) rock(t);end
if impnum==29;rock29=@(t) rock(t);end
if impnum==30;rock30=@(t) rock(t);end


%gridd=linspace(fromt,1,50);
%improct=[improct;roct(gridd,Ximp,Yimp)];


end



rockallk=@(t)avgroctk(t,rock1 ,rock2 ,rock3 ,rock4 ,rock5 ,rock6 ,rock7 ,rock8 ,rock9 ,rock10 ,rock11 ,rock12 ,rock13 ,rock14 ,rock15 ,rock16 ,rock17 ,rock18 ,rock19 ,rock20 ,rock21 ,rock22 ,rock23 ,rock24 ,rock25 ,rock26 ,rock27 ,rock28 ,rock29,rock30);
out=rockallk;

end

end

%plot(t,rockallk(t),'r','LineWidth',2)

